//
// add the following lines to the dmconfig.ini file before running this script
//
// [DBSAMPLE4]
// DB_DBDIR  = /APP_HOME/samples/DATABASE
// DB_PtNum  = 2453
// DB_SvAdr  = 127.0.0.1
// DB_SPDIR  = /APP_HOME/samples/DATABASE
// DB_LBDIR  = /APP_HOME/samples/DATABASE
//

//
// create the database
//
CREATE DB DBSAMPLE4;

//////////////////////////////////////////////////////////////////////
// CREATE TABLE for ESQLC samples
//
CREATE TABLE SYSADM.info (
  name		CHAR(20) ,
  tel		CHAR(20) 
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.Card (
  Num		SERIAL(1) PRIMARY KEY,
  FirstName	VARCHAR(30),
  LastName	VARCHAR(30),
  Title		VARCHAR(30),
  BMP		LONG VARBINARY
) IN DEFTABLESPACE;

INSERT INTO SYSADM.Card VALUES (?,?,?,?,?) ;
1, 'Eddie', 'Chang', 'Manager', &data1.b0(0,6666);
2, 'Hook', 'Hu', 'Software Engineer', &data1.b0(6666,6666);
3, 'Jackie', 'Yu', 'Software Engineer', &data1.b0(13332,6666);
4, 'Ray', 'Sung', 'Software Engineer', &data1.b0(19998,6666);
5, 'Louis', 'Liu', 'Software Engineer', &data1.b0(26664,6666);
6, 'Trent', 'Clowater', 'Software Engineer', &data1.b0(33330,6666);
7, 'Oscar', 'Tseng', 'Software Engineer', &data1.b0(39996,6666);
8, 'Jerry', 'Liu', 'Manager', &data1.b0(46662,6666);
END; 

//////////////////////////////////////////////////////////////////////
// CREATE TABLE for VB DAO sample
//
CREATE TABLE SYSADM.alltype (
  c1		INTEGER,
  c2		SMALLINT,
  c3		CHAR(10),
  c4		VARCHAR(10),
  c5		DATE,
  c6		TIME, 
  c7		TIMESTAMP,
  c8		FLOAT,
  c9		DOUBLE
) IN DEFTABLESPACE;

INSERT INTO alltype VALUES (
 12345, 123,'char type', 'varchar', 
 '1999/12/31', '22:04:05.666', '1997/01/01 10:02:03.444 PM',                    
 3.583837E34, 2.89837457884451E285
);

CREATE COMMAND SYSADM.CommandSELECT AS
  SELECT c1,c2,c3,c4,c5,c6,c7,c8,c9
    FROM SYSADM.alltype;

CREATE COMMAND SYSADM.CommandINSERT AS
  INSERT into SYSADM.alltype
    VALUES(?,?,?,?,?,?,?,?,?);

CREATE COMMAND SYSADM.CommandDELETE AS
  DELETE
    FROM SYSADM.alltype
    WHERE c1=?;

CREATE COMMAND SYSADM.CommandUPDATE AS
  UPDATE SYSADM.alltype
    SET c1=?,c2=?,c3=?,c4=?,c5=?,c6=?,c7=?,c8=?,c9=?
    WHERE c1=?;

//////////////////////////////////////////////////////////////////////
// CREATE TABLE for VB RDO sample
//
LOAD PROC FROM sp1; 

CREATE TABLE SYSADM.DataType_BLOB (
  c1		LONG VARBINARY DEFAULT NULL ,
  c2		LONG VARCHAR DEFAULT NULL ,
  c3		CHAR(5) DEFAULT NULL
) IN DEFTABLESPACE;

INSERT INTO SYSADM.DataType_BLOB VALUES (?,?,?) ;
&data1.b0(0,6666), 'Chang,Eddie', 'Eddie';
&data1.b0(6666,6666), 'Hu,Hook', 'Hook';
END;

CREATE TABLE SYSADM.DataType_Bin (
  c1		BINARY(10)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.DataType_Char (
  c1		CHAR(5),
  c2		VARCHAR(10)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.DataType_Date (
  c1Date	DATE,
  c2Time	TIME,
  c3TimeStamp	TIMESTAMP
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.DataType_File (
  filetyp	CHAR(5),
  fileset	FILE,
  filenum	SERIAL(1)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.DataType_NUM (
  c1Serial	SERIAL(1),
  c2Smallint	SMALLINT,
  c3Int		INTEGER,
  c4Float	FLOAT,
  c5Double	DOUBLE,
  c6Decimal	DECIMAL(17, 6)
) IN DEFTABLESPACE;
CREATE INDEX index1 ON SYSADM.DataType_NUM ( c1Serial ASC );

CREATE TABLE SYSADM.RDO_Test1 (
  c1		INTEGER,
  c2		CHAR(20),
  c3		CHAR(30),
  c4		DATE
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.RdoColumnBlob (
  c1Int		INTEGER,
  c2		LONG VARBINARY
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.TestSample (
  c1Int		INTEGER,
  c2Char	CHAR(10)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.TriggerTable1 (
  C1Int		INTEGER,
  C2Char	CHAR(10),
  C3Varchar	VARCHAR(10)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.TriggerTable2 (
  C1IntNow	INTEGER,
  C1IntOld	INTEGER,
  C2CharNow	CHAR(10),
  C2CharOld	CHAR(10),
  C3VarcharNow	VARCHAR(10),
  C3VarcharOld	VARCHAR(10),
  C4Date	DATE
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.t1 (
  c1		INTEGER,
  c2		CHAR(20)
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.t2 (
  c1		INTEGER PRIMARY KEY,
  c2		INTEGER
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.t3 (
  c1		INTEGER PRIMARY KEY,
  c2		INTEGER,
  FOREIGN KEY fk1 (c2)
    REFERENCES SYSADM.t2 (c1)
    ON UPDATE NO ACTION
    ON DELETE NO ACTION
) IN DEFTABLESPACE;

CREATE TRIGGER Insert
  AFTER INSERT ON SYSADM.TriggerTable1
  FOR EACH ROW (
    INSERT INTO SYSADM.TriggerTable2
      VALUES (
        new.C1Int,
        new.C1Int,
        new.C2Char,
        new.C2Char,
        new.C3Varchar,
        new.C3Varchar,
        CURDATE()
    )
  );
CREATE TRIGGER InsertSP
 BEFORE INSERT ON SYSADM.TriggerTable1
 FOR EACH ROW (
   call sp_Trigger(new.C1Int,new.C2Char,new.C3Varchar)
 );
CREATE TRIGGER TriggerDelete
  BEFORE DELETE ON SYSADM.TriggerTable1
  FOR EACH ROW (
    DELETE
      FROM SYSADM.TriggerTable2
      WHERE C1IntNow=old.C1Int
        AND C2CharNow=old.C2Char
        AND C3VarcharNow=old.C3Varchar
  );
CREATE TRIGGER TriggerUpdate
  AFTER UPDATE ON SYSADM.TriggerTable1
  FOR EACH ROW (
    UPDATE SYSADM.TriggerTable2
      SET
        C1IntNow=new.C1Int,
        C1IntOld=old.C1Int,
        C2CharNow=new.C2Char,
        C2CharOld=old.C2Char,
        C3VarcharNow=new.C3Varchar,
        C3VarcharOld=old.C3Varchar,
        C4Date=CURDATE()
      WHERE C1IntNow=old.C1Int
        AND C2CharNow=old.C2Char
        AND C3VarcharNow=old.C3Varchar
 );

//////////////////////////////////////////////////////////////////////
// create user for PHP3 sample
//
GRANT CONNECT TO voteadm;
GRANT RESOURCE TO voteadm;

//
// CREATE TABLE for PHP3 register sample
//
CREATE TABLE SYSADM.REFER_INFO (
  RID		SERIAL(1) PRIMARY KEY,
  NAME		VARCHAR(50) 
) IN DEFTABLESPACE;

INSERT INTO SYSADM.REFER_INFO VALUES (?,?) ;
1, 'web search';
2, 'tradeshow';
3, 'advertisement';
4, 'mail';
5, 'referal';
6, 'other';
END; 

CREATE TABLE SYSADM.USER_INFO (
  EMAIL		VARCHAR(50) PRIMARY KEY,
  PASSWORD	VARCHAR(16) ,
  SALUTATION	VARCHAR(10) ,
  FIRSTNAME	VARCHAR(20) ,
  LASTNAME	VARCHAR(20) ,
  SUFFIX	VARCHAR(20) ,
  COMPANY	VARCHAR(50) ,
  PHONE		VARCHAR(20) ,
  FAX		VARCHAR(20) ,
  ADDRESS1	VARCHAR(100) ,
  ADDRESS2	VARCHAR(100) ,
  CITY		VARCHAR(30) ,
  STATE		VARCHAR(30) ,
  COUNTRY	VARCHAR(5) ,
  ZIP		VARCHAR(10) ,
  REFER		INTEGER ,
  CREATE_DATE	TIMESTAMP DEFAULT NOW() ,
  MODIFY_DATE	TIMESTAMP DEFAULT NOW() ,
  LAST_ACCESS	TIMESTAMP DEFAULT NOW() ,
  NUM_ACCESS	INTEGER DEFAULT 0 ,
  ACCESS_LEVEL	SMALLINT DEFAULT 1,
  FOREIGN KEY fk1 (REFER)
    REFERENCES REFER_INFO (RID)
    ON UPDATE NO ACTION
    ON DELETE CASCADE
) IN DEFTABLESPACE;
CREATE INDEX idx_country ON SYSADM.USER_INFO ( COUNTRY );
CREATE INDEX idx_create_date ON SYSADM.USER_INFO ( CREATE_DATE );
CREATE INDEX idx_last_access ON SYSADM.USER_INFO ( LAST_ACCESS );

//
// CREATE TABLE for PHP3 poll sample
//
CREATE TABLE voteadm.topic (
  tid		INTEGER PRIMARY KEY ,
  name		VARCHAR(256) ,
  itemnum	SMALLINT DEFAULT 0 ,
  multiselect	INTEGER DEFAULT 0 ,
  multipoll	INTEGER DEFAULT 0 ,
  havecomment	INTEGER DEFAULT 0
) IN DEFTABLESPACE;
INSERT INTO voteadm.topic VALUES (?,?,?,?,?,?) ;
11111, 'Test topic, please delete me from voteadmin.php3', 2, 0, 0, 0;
END; 

CREATE TABLE voteadm.item (
  iid		SERIAL(1) PRIMARY KEY,
  tid		INTEGER ,
  name		VARCHAR(256),
  FOREIGN KEY fk1 (tid)
    REFERENCES voteadm.topic (tid)
    ON UPDATE CASCADE
    ON DELETE CASCADE
) IN DEFTABLESPACE;
INSERT INTO voteadm.item VALUES (?,?,?) ;
2, 11111, 'Test item1';
3, 11111, 'Test item2';
END; 

CREATE TABLE voteadm.vote (
  vid		SERIAL(1) PRIMARY KEY,
  tid		INTEGER ,
  hostname	VARCHAR(128),
  FOREIGN KEY fk1 (tid)
    REFERENCES voteadm.topic (tid)
    ON UPDATE CASCADE
    ON DELETE CASCADE
) IN DEFTABLESPACE;

CREATE TABLE voteadm.voteitem (
  vid		INTEGER NOT NULL  ,
  tid		INTEGER NOT NULL ,
  iid		INTEGER NOT NULL  ,
  comment	VARCHAR(256) ,
  PRIMARY KEY (vid, tid, iid),
  FOREIGN KEY fk1 (tid)
    REFERENCES voteadm.topic (tid)
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY fk2 (iid)
    REFERENCES voteadm.item (iid)
    ON UPDATE CASCADE
    ON DELETE CASCADE,
  FOREIGN KEY fk3 (vid)
    REFERENCES voteadm.vote (vid)
    ON UPDATE CASCADE
    ON DELETE CASCADE
) IN DEFTABLESPACE;
CREATE TRIGGER tg1
  AFTER INSERT ON voteadm.item
  FOR EACH ROW (
    UPDATE voteadm.topic
      SET itemnum=itemnum+1
      WHERE tid=new.tid
  );
CREATE TRIGGER tg2
  AFTER DELETE ON voteadm.item
  FOR EACH ROW (
    UPDATE voteadm.topic
      SET itemnum=itemnum-1
      WHERE tid=old.tid
  );

//////////////////////////////////////////////////////////////////////
// CREATE TABLE for PowerBuilder sample
//
CREATE TABLE SYSADM.emp (
  id		CHAR(6) PRIMARY KEY  ,
  name		CHAR(10) ,
  tel		CHAR(10) ,
  address	VARCHAR(100) ,
  pic		LONG VARBINARY 
) IN DEFTABLESPACE;

//////////////////////////////////////////////////////////////////////
// CREATE TABLE for StoreProc shared object sample
//
CREATE TABLE SYSADM.patient (
  number	SERIAL(1),
  name		CHAR(10) 
) IN DEFTABLESPACE;

CREATE TABLE SYSADM.history (
  regno		INTEGER ,
  number	INTEGER ,
  regtime	TIMESTAMP DEFAULT NOW()
) IN DEFTABLESPACE;

//////////////////////////////////////////////////////////////////////
// create user for Delphi sample
//
GRANT CONNECT TO delphi;
GRANT RESOURCE TO delphi;

//
// CREATE TABLE for Delphi fulltext search sample
//
CREATE TABLE delphi.chinese (
  id		SERIAL(1),
  text		LONG VARCHAR 
) IN DEFTABLESPACE;

CREATE TABLE delphi.fortunes (
  id		SERIAL(1),
  text		LONG VARCHAR 
) IN DEFTABLESPACE;

// insert sample data
LOAD DATA FROM data1;
CREATE TEXT INDEX idx1_chinese ON delphi.chinese ( text );
CREATE TEXT INDEX idx1_fortunes ON delphi.fortunes ( text );

TERMINATE DB;
QUIT;
